package meerkat;

import java.util.List;

/**
 * Created by Vladimir Eliezer Tokarev on 1/22/2016.
 * Those methods will be called when their parallel methods ends running
 * parallel means for instance first some registry will post voter then call HandleVoterPosted
 */
public interface RegistryCallBack {

    /**
     * Runs logic after voter have been posted
     * @param succeeded shows if the adding of the voter succeeded
     */
    void HandleVoterAdded(boolean succeeded);

    /**
     * Runs logic after voter have been removed form group
     * @param succeeded shows if the removing of the voter succeeded
     */
    void HandleVoterAddedToGroup(boolean succeeded);

    /**
     * Runs logic after voter have been added form group
     * @param succeeded shows if the adding of the voter succeeded
     */
    void HandleVoterRemovedFromGroup(boolean succeeded);

    /**
     * Runs logic after voter have voted
     * @param succeeded shows if the voter voting have been documented successfully
     */
    void HandleSetVoted(boolean succeeded);

    /**
     * Handles the voter information
     * @param voterInformation list of information of the voter (its id, and personal data)
     */
    void HandleVoterInfo(List<String> voterInformation);

    /**
     * Handles the groups the voter in
     * @param groupsVoterIn list of groups ids  of the voter
     */
    void HandleVoterGroups(List<String> groupsVoterIn);
}
